class mem_seq4_c extends mem_seq_base_c;

   const string report_id = "MEM_SEQ4";

   `ovm_object_utils(mem_seq4_c)
   
   function new(string name = "mem_seq4_c");
      super.new(name);
   endfunction : new
   
   task body();

      // warning:  this is going to override this class everywhere in the
      // environment which could have unexpected consequences
      mem_item_c::type_id::set_type_override(mem_item_latency4_change_c::get_type());
      repeat (10) begin
         //Have the factory create a mem_item object
         m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         `ovm_info(report_id, m_mem_item_h.convert2string(),OVM_LOW )
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      
      // warning:  this is going to override this class everywhere in the
      // environment which could have unexpected consequences
      mem_item_c::type_id::set_type_override(mem_item_latency_random_c::get_type());
      repeat (10) begin
         //Have the factory create a mem_item object
         m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         `ovm_info(report_id, m_mem_item_h.convert2string(),OVM_LOW )
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
      
   endtask : body

endclass : mem_seq4_c

