class mem_seq2_c extends mem_seq_base_c;

   const string report_id = "MEM_SEQ2";

   `ovm_object_utils(mem_seq2_c)
   
   function new(string name = "mem_seq2_c");
      super.new(name);
   endfunction : new
   
   task body();
      repeat (1000) begin
         //Have the factory create a stimulus object
         m_mem_item_h = mem_item_c::type_id::create("mem_item_c");
         start_item(m_mem_item_h);  //calls wait_for_grant();
         //Need to randomize here (Scenarios randomize in the apply method)
         assert(m_mem_item_h.randomize());
         finish_item(m_mem_item_h);  //calls send_request(m_mem_item_h);
      end
   endtask : body

endclass : mem_seq2_c

